(* Title:  "BaseDefinition/model-pattern.sml"
   Author: Walther Neuper
*)

"-----------------------------------------------------------------------------------------------";
"table of contents -----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"----------- build fun Model_Pattern.parse_pos -----------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
open Model_Pattern;

"----------- build fun Model_Pattern.parse_pos -----------------------------------------------------";
"----------- build fun Model_Pattern.parse_pos -----------------------------------------------------";
"----------- build fun Model_Pattern.parse_pos -----------------------------------------------------";
(*for problem pbl_equ_univ_lin : "LINEAR/univariate/equation"*)
val input_to_Isar = (*vvvvvvvvvvvvv just for correct type    *)
  [(*Given:*)
     ("equality e_e", Position.none),
     ("solveFor v_v", Position.none),
   (*Where:*)
     ("HOL.False", Position.none), (*for strange reasons*)
     ("Not( (lhs e_e) is_polyrat_in v_v)", Position.none),
     ("Not( (rhs e_e) is_polyrat_in v_v)", Position.none),
     ("((lhs e_e) has_degree_in v_v)=1", Position.none),
     ("((rhs e_e) has_degree_in v_v)=1", Position.none),
   (*Find:*)
     ("solutions v_v'i'", Position.none)]

val model_input =
 [("#Given", (*-------------------------------vv=-3727*)
   [("<markup>", {offset=158, end_offset=172, id=3727}), 
    ("<markup>", {offset=173, end_offset=187, id=3727})]),
  ("#Where",
   [("<markup>", {offset=197, end_offset=208, id=3727}),
    ("<markup>", {offset=269, end_offset=304, id=3727}), 
    ("<markup>", {offset=309, end_offset=344, id=3727}),
    ("<markup>", {offset=349, end_offset=382, id=3727}),
    ("<markup>", {offset=386, end_offset=419, id=3727})]),
  ("#Find",
   [("<markup>", {offset=428, end_offset=446, id=3727})])]

val model_input = (*type Position.T is hidden, thus redefinition*)
 [("#Given", (*-------------------------------vv=-3727*)
   [("equality e_e", Position.none), 
    ("solveFor v_v", Position.none)]),
  ("#Where",
   [("HOL.False", Position.none),
    ("Not( (lhs e_e) is_polyrat_in v_v)", Position.none), 
    ("Not( (rhs e_e) is_polyrat_in v_v)", Position.none),
    ("((lhs e_e) has_degree_in v_v)=1", Position.none),
    ("((rhs e_e) has_degree_in v_v)=1", Position.none)]),
  ("#Find",
   [("solutions v_v'i'", Position.none)])]: (m_field * (string * Position.T) list) list

val thy = @{theory LinEq}
val ctxt = Proof_Context.init_global thy;

Model_Pattern.parse_pos ctxt model_input;
"~~~~~ fun parse_pos , args:"; val (model_input) = (model_input);
    val items = model_input |> map (fn (m_field, items) => map (pair m_field) items) |> flat;
    val model = items 
      |> filter_out ((fn f => (fn (f', _) => f = f')) "#Where")
      |> map (parse_term ctxt)
      |> map (split_descriptor ctxt)

: Model_Pattern.pre_model

    val where_ = items
      |> filter ((fn f => (fn (f', _) => f = f')) "#Where") 
      |> map (parse_pattern ctxt)
      |> map (fn (_, a, b) => (a, b))

: (term * Position.T) list
